<?php
/*
-------------------------------------------------------------------------
NetEye Webinject Configtool for Wuerth Phoenix NetEye
Copyright (C) 2010 by WUERTHPHOENIX Srl.
author Patrick Zambelli <patrick.zambelli@wuerth-phoenix.com>

http://www.wuerth-phoenix.com
--------------------------------------------------------------------------

 LICENSE

 This file is part of WuerthPhoenix NetEye ConfigurationTool.

 The NetEye ConfigurationTool is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation version 3 of the License.

 NetEye ConfigurationTool is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You can get a copy of the GNU General Public License included to the Dashboard or
 at http://www.gnu.org/licenses/gpl-3.0.txt. Otherwise write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
*/

require_once dirname(__FILE__).'/includes/config.php.inc';
require_once dirname(__FILE__).'/class.editorForm.php';
require_once dirname(__FILE__).'/class.editorModel.php';

//instantiate classes
//session_start();
$webinjectModel = new editorModel($xmlPath);
$webinjectForm = new editorForm($WI_formwidth, $webinjectModel); 
$message="";

//Show new WebInject Testcase definition form
if (isset($_POST['action']) && ( $_POST['action'] == "show_testcaseDefinitionForm")){
	
	$webinjectForm->drawNewTestcaseDefinitionForm($xmlPath, "");
}

//Run the debug of a testcase
elseif (isset($_POST['action']) && ( $_POST['action'] == "show_MainPage")){
	
	$webinjectForm->drawMainPage($message);	
}

//Run the debug of a testcase
elseif (isset($_POST['action']) && ( $_POST['action'] == "runTestcaseDebug")){
	
	if (!$webinjectModel->verifyConfigXML($xmlPath, $webinjectTestrunPath, $message)) {

		$message.="Warning: It was not possible to update the global config.xml for the execution for the testrun.<br>";
	}

	//array of test results
	$testRunResultsArray = array();

	$webinjectModel->start_testcase_execution($testRunResultsArray, $webinjectExecPath, $webinjectTestrunPath, $_POST['testcase_file'], $message, $xmlPath);
	$webinjectForm->drawTestcaseDebugResults($testRunResultsArray, $message);
	
}

//Parse and edit form of a webinject configuration
elseif (isset($_POST['action']) && ( $_POST['action'] == "editConfigFile")){
	
	$arr_testcases = $webinjectModel->parseTestCases_from_XMLConfiguration($xmlPath.$_POST['testcase_file']);
	if (isset($arr_testcases)){
		
		$webinjectForm->drawEditTestcaseDefinitionForm($arr_testcases, $message, $xmlPath.$_POST['testcase_file'], $_POST['testcase_file']);
	} else {
		
		$message.="Exception while parsing the XML configuration. Abort.";
		$webinjectForm->drawMainPage($message);
	}
	
}

//insert a new SINGLE testcase into the testcases
elseif (isset($_POST['action']) && ( $_POST['action'] == "insertTestcaseToConfigFile")){

	$arr_testcases = $webinjectModel->parseTestCases_from_XMLConfiguration($xmlPath.$_POST['testcase_file']);

	$arr_testcases = $webinjectModel->insertSingleCase($arr_testcases, $_POST['case_insertAtIndex'], $message);
	
	if (isset($arr_testcases)){
		
		//Save the testcase configuration
		//$webinjectModel->prepare_updateOfTestcases($xmlPath.$_POST['testcase_file'], $_POST['testcase_file'], $arr_testcases, $message);

		$webinjectForm->drawEditTestcaseDefinitionForm($arr_testcases, $message, $xmlPath.$_POST['testcase_file'], $_POST['testcase_file']);
	} else {

		$message.="Exception while loading parsing the XML configuration. Abort.";
		$webinjectForm->drawMainPage($message);
	}

}

//remove a SINGLE testcase FROM the testcases
elseif (isset($_POST['action']) && ( $_POST['action'] == "deleteTestcaseToConfigFile")){
	
	$arr_testcasesOrig = $webinjectModel->parseTestCases_from_XMLConfiguration($xmlPath.$_POST['testcase_file']);
	
	$arr_testcases = $webinjectModel->removeSingleCase($arr_testcasesOrig, $_POST['case_DeleteIndex'], $message);
	
	
	if (isset($arr_testcases)){

		//Save the testcase configuration
		//$webinjectModel->prepare_updateOfTestcases($xmlPath.$_POST['testcase_file'], $_POST['testcase_file'], $arr_testcases, $message);
		
		$webinjectForm->drawEditTestcaseDefinitionForm($arr_testcases, $message, $xmlPath.$_POST['testcase_file'], $_POST['testcase_file']);
	} else {

		$message.="Exception while loading parsing the XML configuration. Abort.";
		$webinjectForm->drawMainPage($message);
	}
	
}

//Simple view of a webinject configuration
elseif (isset($_POST['action']) && ( $_POST['action'] == "viewRawXMLConfigFile")){
	
	if (isset($_POST['testcase_file'])){
		
		$webinjectForm->drawRawXMLConfiguration($_POST['testcase_file'], $xmlPath, $message);
	} 
}

//Create a new testcase
elseif (isset($_POST['action']) && ( $_POST['action'] == "submit_createNewTestcaseConfig")) {

	$testcase_name = ""; $testcase_desc = ""; $testcase_url = ""; $testcase_method = ""; $testcase_postbody = "";
	$testcase_posttype = ""; $testcase_verifypositive = ""; $testcase_verifynegative = ""; $testcase_parseresponse = "";
	$testcase_sleep = ""; $testcase_logrequest = ""; $testcase_logresponse = "";
		
	if(isset($_POST['xml_folder']) && ($_POST['xml_folder'] != "")){ $xmlFolder = $_POST['xml_folder']; } else { $xmlFolder = $xmlPath; $message="Warning: Webinject folder path has not been passed correctly.<br>"; }
	if(isset($_POST['testcase_id']) && ($_POST['testcase_id'] != "")){ $testcase_id = $_POST['testcase_id']; } else { $testcase_id = 1; }
	if(isset($_POST['testcase_name']) && ($_POST['testcase_name'] != "")){ $testcase_name = $_POST['testcase_name'].".xml"; }
	if(isset($_POST['testcase_desc']) && ($_POST['testcase_desc'] != "")){ $testcase_desc = $_POST['testcase_desc']; }

	if(isset($_POST['testcase_url']) && ($_POST['testcase_url'] != "")){ $testcase_url = $_POST['testcase_url']; }
	if(isset($_POST['testcase_method']) && ($_POST['testcase_method'] != "")){ $testcase_method = $_POST['testcase_method']; }
	if(isset($_POST['testcase_postbody']) && ($_POST['testcase_postbody'] != "")){ $testcase_postbody = $_POST['testcase_postbody']; }
	if(isset($_POST['testcase_posttype']) && ($_POST['testcase_posttype'] != "")){ $testcase_posttype = $_POST['testcase_posttype']; }
	if(isset($_POST['testcase_verifypositive']) && ($_POST['testcase_verifypositive'] != "")){ $testcase_verifypositive = $_POST['testcase_verifypositive']; }
	if(isset($_POST['testcase_verifynegative']) && ($_POST['testcase_verifynegative'] != "")){ $testcase_verifynegative = $_POST['testcase_verifynegative']; }
	if(isset($_POST['testcase_parseresponse']) && ($_POST['testcase_parseresponse'] != "")){ $testcase_parseresponse = $_POST['testcase_parseresponse']; }
	if(isset($_POST['testcase_sleep']) && ($_POST['testcase_sleep'] != "")){ $testcase_sleep = $_POST['testcase_sleep']; }
	if(isset($_POST['testcase_logrequest']) && ($_POST['testcase_logrequest'] != "")){ $testcase_logrequest = $_POST['testcase_logrequest']; }
	if(isset($_POST['testcase_logresponse']) && ($_POST['testcase_logresponse'] != "")){ $testcase_logresponse = $_POST['testcase_logresponse']; }

	$webinjectModel->defineNewTestcase($xmlFolder, $testcase_id, $testcase_name, $testcase_desc, $testcase_url, $testcase_method, 
		$testcase_postbody, $testcase_posttype, $testcase_verifypositive, $testcase_verifynegative, $testcase_parseresponse, $testcase_sleep, 
		$testcase_logrequest, $testcase_logresponse, $message);
		
	$webinjectModel->registerTestcaseFromConfigXML($testcase_name, $xmlFolder, $message);
	$webinjectModel->editorModel($xmlPath); //Reload the XML files
	$webinjectForm->drawMainPage($message);

}

//EDIT and UPDATE a testcase
elseif (isset($_POST['action']) && (( $_POST['action'] == "submitUpdatedTestcase")) || ( $_POST['action'] == "submitUpdatedTestcaseDone")) {
	
	$testcase_name = ""; $arr_testcase_id[] = ""; $arr_testcase_desc[] = ""; $arr_testcase_url[] = ""; $arr_testcase_method[] = ""; $arr_testcase_postbody[] = "";
	$arr_testcase_posttype[] = ""; $arr_testcase_verifypositive[] = ""; $arr_testcase_verifynegative[] = ""; $arr_testcase_parseresponse[] = "";
	$arr_testcase_sleep[] = "";
	
	$testcase_name = $_POST['testcase_name'];
	
	if(isset($_POST['num_of_testcases']) && ($_POST['num_of_testcases'] != "")) {
		
		
		for ($i=0; $i<$_POST['num_of_testcases'];$i++){

			if(isset($_POST['testcase_id_'.$i])){ $arr_testcase_id[$i] = $_POST['testcase_id_'.$i]; }
			if(isset($_POST['testcase_desc_'.$i])){ $arr_testcase_desc[$i] = $_POST['testcase_desc_'.$i]; }

			if(isset($_POST['testcase_url_'.$i])){ $arr_testcase_url[$i] = $_POST['testcase_url_'.$i]; }
			if(isset($_POST['testcase_method_'.$i])){ $arr_testcase_method[$i] = $_POST['testcase_method_'.$i]; }
			if(isset($_POST['testcase_postbody_'.$i])){ $arr_testcase_postbody[$i] = $_POST['testcase_postbody_'.$i]; }
			if(isset($_POST['testcase_posttype_'.$i]) ){ $arr_testcase_posttype[$i] = $_POST['testcase_posttype_'.$i]; }
			if(isset($_POST['testcase_verifypositive_'.$i])){ $arr_testcase_verifypositive[$i] = $_POST['testcase_verifypositive_'.$i]; }
			if(isset($_POST['testcase_verifynegative_'.$i])){ $arr_testcase_verifynegative[$i] = $_POST['testcase_verifynegative_'.$i]; }
			if(isset($_POST['testcase_parseresponse_'.$i])){ $arr_testcase_parseresponse[$i] = $_POST['testcase_parseresponse_'.$i]; }
			if(isset($_POST['testcase_sleep_'.$i])){ $arr_testcase_sleep[$i] = $_POST['testcase_sleep_'.$i]; }

		}
		
		$webinjectModel->updateTestcases($_POST['xml_fullPath_file'], $testcase_name, $_POST['num_of_testcases'], $arr_testcase_id, $testcase_name, $arr_testcase_desc, $arr_testcase_url, 
		$arr_testcase_method, $arr_testcase_postbody, $arr_testcase_posttype, $arr_testcase_verifypositive, $arr_testcase_verifynegative, 
		$arr_testcase_parseresponse, $arr_testcase_sleep, $message);
		
	} else {
		
		$message.="Warning: There were missing some details, in order to complete the update of the testcase configuration completeley.";
	}
	
	if ($_POST['action'] == "submitUpdatedTestcase"){

		header("Location: ./index.php?message=".$message."&editconf=".$testcase_name);
	} else {
		
		header("Location: ./index.php?message=".$message);
	}
	
}

//Submit: save now the RAW XML data to file
elseif (isset($_POST['action']) && ( $_POST['action'] == "submitSaveRawXMLConfigFile")) {
	
	if (isset($_POST['XMLFile_fullPath']) && $_POST['XMLFile_fullPath'] != ""){
		
		$webinjectModel->writeRawXMLtoFile ($_POST['webinjectRawXMLTestcases'], $_POST['XMLFile_fullPath'], $message); 
	}
	
	$webinjectForm->drawMainPage($message);
	
}

//Form: ask for the confirmation to remove the webinject configuration 
elseif (isset($_POST['action']) && ( $_POST['action'] == "showDeleteWebinjectConfForm")) {
	
	$webinjectForm->drawRemoveWebinjectConfForm($_POST['configFile'], $message."Are you sure to delete the Webinject Testcase configuration ?");	
}

//Submit: execute the remove of the webinject configuration 
elseif (isset($_POST['action']) && ( $_POST['action'] == "confirmedDeleteWebinjectConfExec")) {
	
	$webinjectModel->removeTestcaseConfiguration($_POST['configFile'], $xmlPath, $message);
	$webinjectModel->editorModel($xmlPath); //Reload the XML files
	$webinjectForm->drawMainPage($message);
	
}

//Show: Configuration examples for the configuration of the testcase in Nagios 
elseif (isset($_POST['action']) && ( $_POST['action'] == "showConfigureInNagios")) {
	
	$webinjectForm->drawNagiosConfigForm($_POST['configFile'], $message);
	
}



else {
	echo "<table width=\"300\"><tr><td><h2>General exception.</h2><a href=\"index.php\" class=\"button\" onclick=\"\"><span> Back </span></a></td></td></table>";
}
?>